import animate from './animate.js'

const AnimatedWeakMap = class {
	constructor () {
		this.weakMap = new WeakMap()
	}
	delete (key) {
		this.weakMap.delete(key)
		animate()
	}
	get (key) {
		return this.weakMap.get(key)
	}
	has (key) {
		return this.weakMap.has(key)
	}
	set (key, value) {
		this.weakMap.set(key, value)
		animate()
	}
}

export default AnimatedWeakMap
