import collabThread from './collabThread.js'
import DecCollabIdInt from './DecCollabIdInt.js'
import IncCollabIdInt from './IncCollabIdInt.js'

let time = '00000'
const Part = (int) => {
	const part = collabThread + int + time + '1'
	time = IncCollabIdInt(time)
	return part
}
const SiblingAfter = (position, i) => {
	return position.slice(0, i) + Part(IncCollabIdInt(position.slice(i + 13, i + 18)))
}
const SiblingBefore = (position, i) => {
	return position.slice(0, i) + Part(DecCollabIdInt(position.slice(i + 13, i + 18)))
}
const ChildAfter = (position) => {
	return position + Part('I0000')
}
const ChildBefore = (position) => {
	return position.slice(0, -1) + '0' + Part('I0000')
}
const SiblingOrChildAfter = (position, i) => {
	for (let j = i; j < position.length; j += 24) {
		if (position.slice(j, j + 13) === collabThread) {
			return SiblingAfter(position, j)
		}
	}
	return ChildAfter(position)
}
const SiblingOrChildBefore = (position, i) => {
	for (let j = i; j < position.length; j += 24) {
		if (position.slice(j, j + 13) === collabThread) {
			return SiblingBefore(position, j)
		}
	}
	return ChildBefore(position)
}
const CollabPosition = (afterPositionOrNull, beforePositionOrNull) => {
	if (afterPositionOrNull !== null && beforePositionOrNull !== null) {
		const minLength = Math.min(afterPositionOrNull.length, beforePositionOrNull.length)
		for (let i = 0; i < minLength; i += 24) {
			const afterThread = afterPositionOrNull.slice(i, i + 13)
			const beforeThread = beforePositionOrNull.slice(i, i + 13)
			if (afterThread !== beforeThread) {
				if (afterThread === collabThread) {
					return SiblingAfter(afterPositionOrNull, i)
				}
				if (beforeThread === collabThread) {
					return SiblingBefore(beforePositionOrNull, i)
				}
			}
		}
		if (afterPositionOrNull.length > beforePositionOrNull.length) {
			return SiblingOrChildAfter(afterPositionOrNull, beforePositionOrNull.length)
		}
		if (beforePositionOrNull.length > afterPositionOrNull.length) {
			return SiblingOrChildBefore(beforePositionOrNull, afterPositionOrNull.length)
		}
		return ChildAfter(afterPositionOrNull)
	}
	if (afterPositionOrNull !== null) {
		return SiblingOrChildAfter(afterPositionOrNull, 0)
	}
	if (beforePositionOrNull !== null) {
		return SiblingOrChildBefore(beforePositionOrNull, 0)
	}
	return Part('I0000')
}

export default CollabPosition
