import fs from 'node:fs'

const FsPathExists = (path) => {
	return new Promise((resolve, reject) => {
		fs.access(path, (errorOrFalsyValue) => {
			if (errorOrFalsyValue) {
				if (errorOrFalsyValue.code === 'ENOENT') {
					resolve(false)
				} else {
					reject(errorOrFalsyValue)
				}
			} else {
				resolve(true)
			}
		})
	})
}

export default FsPathExists
