import CollabPositionComparison from './CollabPositionComparison.js'
import QcPlaylistMap from './QcPlaylistMap.js'
import QcsMediaExists from './QcsMediaExists.js'

const cache = new Map()
const QcPlaylistPositions = (playlist) => {
	if (!cache.has(playlist)) {
		const map = QcPlaylistMap(playlist)
		const positions = [...map.keys()].filter((position) => {
			return QcsMediaExists(map.get(position))
		})
		positions.sort(CollabPositionComparison)
		cache.set(playlist, positions)
	}
	return cache.get(playlist)
}
QcPlaylistMap.onChange(() => {
	cache.clear()
})
QcsMediaExists.onChange(() => {
	cache.clear()
})

export default QcPlaylistPositions
