import QcsMediaExists from './QcsMediaExists.js'
import CollabPositionComparison from './CollabPositionComparison.js'
import qcQueueMap from './qcQueueMap.js'

let cache = null
const QcQueuePositions = () => {
	if (cache === null) {
		cache = [...qcQueueMap.keys()].filter((position) => {
			const value = qcQueueMap.get(position)
			return QcsMediaExists(value.track) && (value.playlist === undefined || QcsMediaExists(value.playlist))
		})
		cache.sort(CollabPositionComparison)
	}
	return cache
}
qcQueueMap.onChange(() => {
	cache = null
})
QcsMediaExists.onChange(() => {
	cache = null
})

export default QcQueuePositions
