import QcsMediaExists from './QcsMediaExists.js'
import CollabPositionComparison from './CollabPositionComparison.js'
import qcSkipBackMap from './qcSkipBackMap.js'

let cache = null
const QcSkipBackPositions = () => {
	if (cache === null) {
		cache = [...qcSkipBackMap.keys()].filter((position) => {
			const info = qcSkipBackMap.get(position)
			return QcsMediaExists(info.track) && (info.playlist === undefined || QcsMediaExists(info.playlist))
		})
		cache.sort(CollabPositionComparison)
	}
	return cache
}
qcSkipBackMap.onChange(() => {
	cache = null
})
QcsMediaExists.onChange(() => {
	cache = null
})

export default QcSkipBackPositions
