import QcTitleBarButton from './QcTitleBarButton.js'
import QcTitleBarForm from './QcTitleBarForm.js'
import QcTitleBar from './QcTitleBar.js'
import QcMainUl from './QcMainUl.js'
import QcMain from './QcMain.js'
import QcTitleBarInput from './QcTitleBarInput.js'
import setElChild from './setElChild.js'
import AnimatedRef from './AnimatedRef.js'
import animators from './animators.js'
import qcFetchOkJsonOrNull from './qcFetchOkJsonOrNull.js'
import QcShouldShowYtResult from './QcShouldShowYtResult.js'
import QcYtResultLi from './QcYtResultLi.js'
import QueryString from './QueryString.js'

const WelcomeMain = () => {
	const main = QcMain()
	main.appendChild(document.createTextNode('yt search page message'))
	return main
}
const ResultsMain = (tabAfterTick, pageAfterTick, results) => {
	const main = QcMain()
	main.appendChild(results.length === 0 ? document.createTextNode('no results message') : (() => {
		const ul = QcMainUl()
		for (const result of results) {
			if (QcShouldShowYtResult(result)) {
				ul.appendChild(QcYtResultLi(tabAfterTick, pageAfterTick, result))
			}
		}
		return ul
	})())
	return main
}
const QcYtSearchPage = (tabAfterTick) => {
	const mainRef = new AnimatedRef(WelcomeMain())
	const page = {
		titleBar: (() => {
			const bar = QcTitleBar()
			const input = QcTitleBarInput()
			const queryRef = new AnimatedRef('')
			input.addEventListener('input', () => {
				queryRef.value = input.value
			}, {passive: true})
			animators.set(input, () => {
				input.value = queryRef.value
			})
			const loadOrNullRef = new AnimatedRef(null)
			bar.appendChild((() => {
				const form = QcTitleBarForm()
				form.addEventListener('submit', async (event) => {
					event.preventDefault()
					input.blur()
					if (queryRef.value === '') {
						loadOrNullRef.value = null
						mainRef.value = WelcomeMain()
					} else {
						const load = {}
						loadOrNullRef.value = load
						const resultsOrNull = await qcFetchOkJsonOrNull('/ytSearchResultsOrNull?' + QueryString({query: queryRef.value}))
						if (load === loadOrNullRef.value) {
							loadOrNullRef.value = null
							if (resultsOrNull === null) {
								alert('error message')
							} else {
								mainRef.value = ResultsMain(tabAfterTick, page, resultsOrNull)
							}
						}
					}
				})
				form.appendChild(input)
				return form
			})())
			bar.appendChild((() => {
				const button = QcTitleBarButton()
				button.addEventListener('click', () => {
					if (loadOrNullRef.value === null) {
						input.focus()
						queryRef.value = ''
					} else {
						loadOrNullRef.value = null
					}
				}, {passive: true})
				const clearIcon = document.createTextNode('❌')
				const loadingIcon = document.createTextNode('⌛')
				animators.set(button, () => {
					setElChild(button, loadOrNullRef.value === null ? clearIcon : loadingIcon)
					button.style.display = loadOrNullRef.value === null ? (queryRef.value === '' ? 'none' : '') : ''
				})
				return button
			})())
			return bar
		})(),
		main: () => {
			return mainRef.value
		},
	}
	return page
}

export default QcYtSearchPage
