import os from 'node:os'
import qsWriteDebuggingInfo from './qsWriteDebuggingInfo.js'

const prioritizedNetworkInterfaceKeys = ['en0', 'Wi-Fi']
// https://stackoverflow.com/questions/29958143/what-are-en0-en1-p2p-and-so-on-that-are-displayed-after-executing-ifconfig
const QsRemoteQcUriOrNull = () => {
	const interfaces = os.networkInterfaces()
	qsWriteDebuggingInfo('qsRemoteQcUriOrNullInterfaces', interfaces)
	const matchingDescriptorOrUndefined = Object.keys(interfaces).sort((a, b) => {
		return prioritizedNetworkInterfaceKeys.indexOf(b) - prioritizedNetworkInterfaceKeys.indexOf(a)
	}).map((k) => {
		return interfaces[k]
	}).flat().find((descriptor) => {
		return descriptor.family === 'IPv4' && !descriptor.internal
	})
	return matchingDescriptorOrUndefined === undefined ? null : 'http://' + matchingDescriptorOrUndefined.address + ':29749'
}

export default QsRemoteQcUriOrNull
