import fs from 'node:fs'

const ReadFdOrNull = (file) => {
	return new Promise((resolve, reject) => {
		fs.open(file, (errorOrFalsyValue, fdIfNotErrorOrFalsyValue) => {
			if (errorOrFalsyValue) {
				if (errorOrFalsyValue.code === 'ENOENT') {
					resolve(null)
				} else {
					reject(errorOrFalsyValue)
				}
			} else {
				resolve(fdIfNotErrorOrFalsyValue)
			}
		})
	})
}

export default ReadFdOrNull
