import postAnimators from './postAnimators.js'
import animators from './animators.js'

const animateEl = (el) => {
	if (animators.has(el)) {
		animators.get(el)()
	}
	for (const child of el.children) {
		animateEl(child)
	}
	if (postAnimators.has(el)) {
		postAnimators.get(el)()
	}
}
let isAnimated = false
const animate = () => {
	if (!isAnimated) {
		requestAnimationFrame(() => {
			isAnimated = false
			animateEl(document.body)
		})
		isAnimated = true
	}
}
export default animate
