import QcQueueGroups from './QcQueueGroups.js'
import ArrayLastValue from './ArrayLastValue.js'
import qcSkipForward from './qcSkipForward.js'
import QcsMediaExists from './QcsMediaExists.js'
import qcsCollabMap from './qcsCollabMap.js'
import QcQueuePositions from './QcQueuePositions.js'
import QcQueueIsPlaying from './QcQueueIsPlaying.js'
import assert from './assert.js'
import CollabPosition from './CollabPosition.js'

const qcBumpTrack = (track) => {
	if (QcsMediaExists(track)) {
		const queueInfoAsJsonOrEmptyString = qcsCollabMap.get('media-' + track + '-queueInfo')
		const positions = QcQueuePositions()
		if (queueInfoAsJsonOrEmptyString === '') {
			if (positions.length === 0) {
				QcQueueIsPlaying.set(false)
			}
			qcsCollabMap.set('media-' + track + '-queueInfo', JSON.stringify({position: CollabPosition(positions.length === 0 ? null : positions[positions.length - 1], null)}))
		} else {
			const currentPosition = JSON.parse(queueInfoAsJsonOrEmptyString).position
			const currentIndex = positions.indexOf(currentPosition)
			assert(currentIndex !== -1)
			if (currentIndex === 0) {
				if (!QcQueueIsPlaying()) {
					QcQueueIsPlaying.set(true)
				}
			} else if (currentIndex === 1 && QcQueueIsPlaying()) {
				qcSkipForward()
			} else {
				const groups = QcQueueGroups()
				const currentGroupIndex = groups.findIndex((group) => {
					return group.includes(currentPosition)
				})
				assert(currentGroupIndex !== -1)
				assert(currentGroupIndex !== 0)
				if (currentGroupIndex === 1 && QcQueueIsPlaying()) {
					assert(currentIndex > 1)
					qcsCollabMap.set('media-' + track + '-queueInfo', JSON.stringify({position: CollabPosition(positions[0], positions[1])}))
				} else {
					qcsCollabMap.set('media-' + track + '-queueInfo', JSON.stringify({position: CollabPosition(currentGroupIndex === 1 ? null : ArrayLastValue(groups[currentGroupIndex - 2]), groups[currentGroupIndex - 1][0])}))
				}
			}
		}
	}
}

export default qcBumpTrack
