import QcMountedMainOrNull from './QcMountedMainOrNull.js'
import qcFetchOkJsonOrNull from './qcFetchOkJsonOrNull.js'
import postAnimators from './postAnimators.js'
import QcButton from './QcButton.js'
import setElChild from './setElChild.js'
import animators from './animators.js'
import animate from './animate.js'
import qcCurrentTabRef from './qcCurrentTabRef.js'
import qcQueueTab from './qcQueueTab.js'
import qcRecentsTab from './qcRecentsTab.js'
import qcYtTab from './qcYtTab.js'

document.body.classList.add('body')
let animationMain
const mainScrollInfo = new WeakMap()
animators.set(document.body, () => {
	animationMain = qcCurrentTabRef.value.pageRef.value.main()
	const mountedMainOrNull = QcMountedMainOrNull()
	if (mountedMainOrNull !== animationMain && mountedMainOrNull !== null) {
		mainScrollInfo.set(mountedMainOrNull, {left: document.documentElement.scrollLeft, top: document.documentElement.scrollTop})
	}
})
document.body.appendChild((() => {
	const header = document.createElement('header')
	header.appendChild((() => {
		const topBar = document.createElement('div')
		topBar.classList.add('topBar')
		topBar.appendChild((() => {
			const tabBar = document.createElement('nav')
			tabBar.classList.add('tabBar')
			const Button = (tab, name) => {
				const button = QcButton()
				button.classList.add('tabButton')
				button.addEventListener('click', () => {
					qcCurrentTabRef.value = tab
				}, {passive: true})
				button.appendChild(document.createTextNode(name))
				animators.set(button, () => {
					button.classList.toggle('currentTabButton', tab === qcCurrentTabRef.value)
				})
				return button
			}
			tabBar.appendChild(Button(qcQueueTab, 'Queue'))
			tabBar.appendChild(Button(qcRecentsTab, 'Recents'))
			tabBar.appendChild(Button(qcYtTab, 'YouTube'))
			return tabBar
		})())
		topBar.appendChild((() => {
			const titleBarDiv = document.createElement('div')
			animators.set(titleBarDiv, () => {
				setElChild(titleBarDiv, qcCurrentTabRef.value.pageRef.value.titleBar)
			})
			return titleBarDiv
		})())
		return topBar
	})())
	header.appendChild((() => {
		const logoButtonDiv = document.createElement('div')
		logoButtonDiv.classList.add('logoButtonDiv')
		logoButtonDiv.appendChild((() => {
			const logoButton = QcButton()
			logoButton.classList.add('logoButton')
			logoButton.addEventListener('click', async () => {
				const uriOrNull = await qcFetchOkJsonOrNull('/remoteQcUriOrNull')
				if (uriOrNull === null) {
					alert('Something went wrong getting the link :(')
				} else {
					alert(uriOrNull)
					// if (confirm('The link to this queue is '+uriOrNull+'. Press OK to copy it to the clipboard.')) {
					// 	console.log('copy')
					// }else {
					// 	console.log('nocopu')
					// }
				}
			})
			logoButton.appendChild(document.createTextNode('🔗'))
			return logoButton
		})())
		return logoButtonDiv
	})())
	return header
})())
document.body.appendChild((() => {
	const mainDiv = document.createElement('div')
	animators.set(mainDiv, () => {
		setElChild(mainDiv, animationMain)
	})
	return mainDiv
})())
postAnimators.set(document.body, () => {
	if (QcMountedMainOrNull() !== animationMain) {
		if (mainScrollInfo.has(animationMain)) {
			const info = mainScrollInfo.get(animationMain)
			document.documentElement.scroll(info.left, info.top)
		} else {
			document.documentElement.scroll(0, 0)
		}
		QcMountedMainOrNull.set(animationMain)
	}
})
animate()
