import qcsCollabMap from './qcsCollabMap.js'

const qcSkipBackMap = new Map()
for (const [key, value] of qcsCollabMap) {
	const matchOrNull = key.match(/^media-([^-]*)-skipBackInfo$/)
	if (matchOrNull !== null) {
		const [, track] = matchOrNull
		qcSkipBackMap.set(JSON.parse(value).position, {track: track})
	}
}
for (const [key, value] of qcsCollabMap) {
	const matchOrNull = key.match(/^media-([^-]*)-playlists-([^-]*)-skipBackInfo$/)
	if (matchOrNull !== null) {
		const [, track, playlist] = matchOrNull
		qcSkipBackMap.set(JSON.parse(value).position, {track: track, playlist: playlist})
	}
}
qcsCollabMap.changeHandlers.push((change) => {
	const matchOrNull = change.key.match(/^media-([^-]*)-skipBackInfo$/)
	if (matchOrNull !== null) {
		const [, track] = matchOrNull
		if (change.oldValue !== '') {
			qcSkipBackMap.delete(JSON.parse(change.oldValue).position)
		}
		if (change.value !== '') {
			qcSkipBackMap.set(JSON.parse(change.value).position, {track: track})
		}
	}
})
qcsCollabMap.changeHandlers.push((change) => {
	const matchOrNull = change.key.match(/^media-([^-]*)-playlists-([^-]*)-skipBackInfo$/)
	if (matchOrNull !== null) {
		const [, track, playlist] = matchOrNull
		if (change.oldValue !== '') {
			qcSkipBackMap.delete(JSON.parse(change.oldValue).position)
		}
		if (change.value !== '') {
			qcSkipBackMap.set(JSON.parse(change.value).position, {track: track, playlist: playlist})
		}
	}
})
qcSkipBackMap.onChange = (fn) => {
	qcsCollabMap.changeHandlers.push((change) => {
		if (
			/^media-[^-]*-skipBackInfo$/.test(change.key)
			|| /^media-[^-]*-playlists-[^-]*-skipBackInfo$/.test(change.key)
		) {
			fn()
		}
	})
}

export default qcSkipBackMap
