import ArrayLastValue from './ArrayLastValue.js'
import QcQueueGroups from './QcQueueGroups.js'
import QcQueuePlayInfo from './QcQueuePlayInfo.js'
import qcSkipBack from './qcSkipBack.js'
import QcsMediaExists from './QcsMediaExists.js'
import qcsCollabMap from './qcsCollabMap.js'
import QcQueuePositions from './QcQueuePositions.js'
import QcQueueIsPlaying from './QcQueueIsPlaying.js'
import assert from './assert.js'
import CollabPosition from './CollabPosition.js'

const qcUnbumpTrack = (track) => {
	if (QcsMediaExists(track)) {
		const queueInfoAsJsonOrEmptyString = qcsCollabMap.get('media-' + track + '-queueInfo')
		if (queueInfoAsJsonOrEmptyString !== '') {
			const positions = QcQueuePositions()
			const currentPosition = JSON.parse(queueInfoAsJsonOrEmptyString).position
			const currentIndex = positions.indexOf(currentPosition)
			assert(currentIndex !== -1)
			let unbumped = false
			if (currentIndex === 0 && QcQueueIsPlaying()) {
				const playInfo = QcQueuePlayInfo()
				if (playInfo.sourceTrack === track && playInfo.sourcePlaylist === undefined) {
					QcQueueIsPlaying.set(false)
					unbumped = true
				} else {
					unbumped = qcSkipBack()
				}
			}
			if (!unbumped) {
				if (currentIndex === positions.length - 1) {
					qcsCollabMap.delete('media-' + track + '-queueInfo')
				} else {
					const groups = QcQueueGroups()
					const currentGroupIndex = groups.findIndex((group) => {
						return group.includes(currentPosition)
					})
					assert(currentGroupIndex !== -1)
					assert(currentGroupIndex !== groups.length - 1)
					qcsCollabMap.set('media-' + track + '-queueInfo', JSON.stringify({position: CollabPosition(ArrayLastValue(groups[currentGroupIndex + 1]), currentGroupIndex === groups.length - 2 ? null : groups[currentGroupIndex + 2][0])}))
				}
			}
		}
	}
}

export default qcUnbumpTrack
