import qpsPackageInfo from './qpsPackageInfo.js'
import qpsPackage from './qpsPackage.js'
import ChildProcess from 'node:child_process'
import FsPath from 'node:path'

const qp = (optionsOrUndefined) => {
	;(async () => {
		const staticOptions = optionsOrUndefined === undefined ? {} : JSON.parse(JSON.stringify(optionsOrUndefined))
		let sequenceIndex = 0
		while (true) {
			if (!staticOptions.dev && !staticOptions.noUpdate) {
				if (sequenceIndex === 0) {
					console.log('Checking for updates...')
				}
				await new Promise((resolve, reject) => {
					ChildProcess.execFile(
						FsPath.join(process.execPath, '..', process.platform === 'win32' ? 'npm.cmd' : 'npm'),
						['update', '--global', qpsPackageInfo.name],
						{},
						(errorOrFalsyValue) => {
							if (errorOrFalsyValue) {
								reject(errorOrFalsyValue)
							} else {
								resolve()
							}
						},
					)
				})
			}
			if (sequenceIndex === 0) {
				console.log('Setting up...')
			}
			if (await new Promise((resolve) => {
				ChildProcess.fork(
					FsPath.join(qpsPackage, 'src', 'qs.js'),
					[JSON.stringify({options: staticOptions, sequenceIndex: sequenceIndex})],
				).on('exit', (exitCodeOrNull) => {
					resolve(exitCodeOrNull !== 90)
				})
			})) {
				break
			}
			sequenceIndex++
		}
	})()
}

export default qp
