import fs from 'node:fs'
import FsPath from 'node:path'
import qsArg from './qsArg.js'
import qpsPackage from './qpsPackage.js'

const file = FsPath.join(qpsPackage, 'dist', 'bundledQcSetup.js')
if (qsArg.options.dev) {
	const [rollup, commonjs, nodeResolve] = await Promise.all([
		import('rollup'),
		import('@rollup/plugin-commonjs'),
		import('@rollup/plugin-node-resolve'),
	])
	const bundle = await rollup.rollup({
		input: FsPath.join(qpsPackage, 'src', 'qcSetup.js'),
		plugins: [commonjs.default(), nodeResolve.nodeResolve({browser: true})],
	})
	await bundle.write({file: file, format: 'es'})
	bundle.close()
}
const qsBundledQcSetupJs = await fs.promises.readFile(file, {encoding: 'utf8'})

export default qsBundledQcSetupJs
